#3057 closed defect (fixed)

Add a workaround for the LEON3FT store-store errata

Reported by: Sebastian Huber Owned by: Daniel Hellstrom
Priority: normal Milestone: 5.1
Component: tool/gcc Version:
Severity: blocker Keywords:
Cc: Blocked By:
Blocking:

Description

GCC needs support to provide a workaround for the LEON3FT store-store errata, e.g.

https://gcc.gnu.org/ml/gcc-patches/2017-06/msg01577.html

and follow up versions.

Attachments (1)

0001-config-sparc-sparc.opt-mfix-ut700-New-option.patch (12.4 KB) - added by Sebastian Huber on Jul 17, 2017 at 5:51:39 AM.

Download all attachments as: .zip

Change History (7)

comment:1 Changed on Jul 12, 2017 at 9:19:20 AM by Sebastian Huber

Something was added to GCC 7 branch:

https://gcc.gnu.org/viewcvs/gcc?view=revision&revision=250121

Fix is incomplete.

comment:2 Changed on Jul 17, 2017 at 5:42:46 AM by Daniel Cederman <cederman@…>

In 2f8704b6/rtems:

sparc: Add assembly workaround for LEON3FT B2BST errata

This patch adds NOP instructions to prevent instruction sequences
that are sensitive to the LEON3FT B2BST errata. See GRLIB-TN-0009:
"LEON3FT Stale Cache Entry After Store with Data Tag Parity Error"
for more information.

The sequences are only modified if FIX_LEON3FT_B2BST is defined.

The patch works in conjunction with the -mfix-ut700, -mfix-gr712rc,
and -mfix-ut699 GCC flags that prevents the sensitive sequences from
being generated.

Update #3057.

comment:3 Changed on Jul 17, 2017 at 5:45:23 AM by Daniel Cederman <cederman@…>

In 4debaca6/rtems:

bsps/sparc: Add leon3 BSP variants

Rename NGMP to GR740 and add configs for UT699, UT700, and GR712RC

The UT699 requires -mcpu=leon as it does not support the CAS instruction
provided by -mcpu=leon3. It also requires -mfix-ut699 for errata fixes.

UT700 and GR712RC requires the -mfix-ut700 and -mfix-gr712rc flags that
have been recently added to GCC's master and 7-branch.

Remove -msoft-float from the leon3 config to make the more common case
of using the FPU the default.

Update #3057.

comment:4 Changed on Jul 17, 2017 at 6:31:35 AM by Sebastian Huber <sebastian.huber@…>

Resolution: fixed
Status: assignedclosed

In e2952bb/rtems-source-builder:

4.12: Add LEON3FT store-store errata workaround

Close #3057.

comment:5 Changed on Oct 10, 2017 at 5:58:26 AM by Sebastian Huber

Component: GCCtool/gcc

comment:6 Changed on Nov 9, 2017 at 6:27:14 AM by Sebastian Huber

Milestone: 4.12.05.1

Milestone renamed

Note: See TracTickets for help on using tickets.